<template>
    <div class="invite">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-pa-md">
                    <div class="col-5 col-md-2 col-lg-2">
                        <div class="title items-center text-center">
                            <p class="helvetica-neue-medium q-pa-lg">
                                {{ $t('invite.title') }}
                            </p>
                        </div>
                    </div>

                    <!-- MOBILE VIEW -->
                    <div class="col-5 row justify-end items-center lt-md">
                        <auto-assign
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>
                    <div class="col-2 row justify-center items-center lt-md">
                        <notifications v-if="windowWidth <= 450"
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>

                    <div
                        class="
                            col-2
                            offset-7
                            row
                            justify-end
                            items-center
                            gt-sm
                        "
                    >
                        <auto-assign />
                    </div>
                    <div
                        class="
                            col-1
                            row
                            justify-center
                            items-center
                            q-pr-lg
                            gt-sm
                        "
                    >
                        <notifications v-if="windowWidth > 450" />
                    </div>
                </div>

                <div class="row q-px-md">
                    <div class="col-12">
                        <div
                            class="
                                page-content
                                items-center
                                q-pt-lg q-pb-lg q-px-xl
                            "
                            @click="state.searchResults = false"
                        >
                            <div class="row">
                                <div
                                    class="col-12 col-md-4 col-lg-4 offset-md-1"
                                >
                                    <q-input
                                        outlined
                                        bottom-slots
                                        v-model="search"
                                        :label="$t('invite.search')"
                                        :dense="dense"
                                        :loading="state.loadingState"
                                        debounce="500"
                                        bg-color="transparent"
                                        clearable
                                    >
                                        <template v-slot:prepend>
                                            <q-icon
                                                name="search"
                                                class="text-5B9ADD"
                                            />
                                        </template>
                                    </q-input>

                                    <!-- SEARCH RESULTS -->
                                    <div
                                        class="searchResults"
                                        v-if="state.searchResults"
                                    >
                                        <q-list class="q-pa-md">
                                            <q-item
                                                :class="
                                                    list.status == 1
                                                        ? 'active q-py-sm q-my-sm'
                                                        : 'q-py-sm q-my-sm'
                                                "
                                                :disable="
                                                    list.status == 2
                                                        ? true
                                                        : false
                                                "
                                                :clickable="
                                                    list.status == 2
                                                        ? false
                                                        : true
                                                "
                                                v-ripple
                                                v-for="(
                                                    list, index
                                                ) in state.searchList"
                                                :key="'invite-' + index"
                                                @click="selectListPressed(list)"
                                            >
                                                <q-item-section avatar>
                                                    <q-img
                                                        class="border-radius-50"
                                                        :src="
                                                            list.imageUrl
                                                                ? list.imageUrl
                                                                : '/images/default.png'
                                                        "
                                                    />
                                                </q-item-section>
                                                <q-item-section>
                                                    <q-item-label>
                                                        <p
                                                            :class="
                                                                list.status == 2
                                                                    ? 'text-invited font-16'
                                                                    : 'font-16'
                                                            "
                                                        >
                                                            {{ list.name }}
                                                            <span
                                                                v-if="
                                                                    list.status ==
                                                                    2
                                                                "
                                                                class="
                                                                    q-py-xs
                                                                    q-px-sm
                                                                    invited-pill
                                                                    text-uppercase
                                                                "
                                                            >
                                                                {{
                                                                    $t(
                                                                        'invite.alreadyInvited'
                                                                    )
                                                                }}
                                                            </span>
                                                        </p>
                                                    </q-item-label>
                                                    <q-item-label>
                                                        <p
                                                            class="
                                                                text-777777
                                                                font-16
                                                            "
                                                        >
                                                            {{ list.username }}
                                                        </p>
                                                    </q-item-label>
                                                </q-item-section>
                                            </q-item>
                                        </q-list>
                                    </div>
                                </div>
                                <div class="col-6 col-md-3 col-lg-3">
                                    <p
                                        class="
                                            font-18
                                            text-888888
                                            q-pa-xs
                                            text-right
                                        "
                                    >
                                        {{ $t('invite.showSelected') }}({{
                                            state.selectedList
                                        }})
                                    </p>
                                </div>
                                <div class="col-6 col-md-3 col-lg-3 text-right">
                                    <q-btn
                                        flat
                                        class="font-16 text-5B9ADD"
                                        @click="selectAllPressed"
                                    >
                                        {{ $t('button.selectAll') }}
                                    </q-btn>
                                </div>
                            </div>

                            <!-- LIST -->
                            <div
                                class="row"
                                v-if="state.invitationList.length > 0"
                            >
                                <div
                                    class="
                                        col-12 col-md-10 col-lg-10
                                        offset-md-1
                                    "
                                >
                                    <q-list>
                                        <q-item
                                            :class="
                                                list.status == 1
                                                    ? 'active q-py-sm q-my-sm'
                                                    : 'q-py-sm q-my-sm'
                                            "
                                            :disable="
                                                list.status == 2 ? true : false
                                            "
                                            :clickable="
                                                list.status == 2 ? false : true
                                            "
                                            v-ripple
                                            v-for="(
                                                list, index
                                            ) in state.invitationList"
                                            :key="'invite-' + index"
                                            @click="
                                                selectInvitationListPressed(
                                                    list.id
                                                )
                                            "
                                        >
                                            <q-item-section avatar>
                                                <q-img
                                                    class="border-radius-50"
                                                    :src="
                                                        list.imageUrl
                                                            ? list.imageUrl
                                                            : '/images/default.png'
                                                    "
                                                />
                                            </q-item-section>
                                            <q-item-section>
                                                <q-item-label>
                                                    <p
                                                        :class="
                                                            list.status == 2
                                                                ? 'text-invited font-16'
                                                                : 'font-16'
                                                        "
                                                    >
                                                        {{ list.name }}
                                                        <span
                                                            v-if="
                                                                list.status == 2
                                                            "
                                                            class="
                                                                q-py-xs q-px-sm
                                                                invited-pill
                                                                text-uppercase
                                                            "
                                                        >
                                                            {{
                                                                $t(
                                                                    'invite.alreadyInvited'
                                                                )
                                                            }}
                                                        </span>
                                                    </p>
                                                </q-item-label>
                                                <q-item-label>
                                                    <p
                                                        class="
                                                            text-777777
                                                            font-16
                                                        "
                                                    >
                                                        {{ list.username }}
                                                    </p>
                                                </q-item-label>
                                            </q-item-section>
                                            <q-item-section avatar>
                                                <q-img
                                                    v-if="list.status == 2"
                                                    src="/images/selected.png"
                                                />
                                                <q-img
                                                    v-else-if="list.status == 1"
                                                    src="/images/select.png"
                                                />
                                                <q-img
                                                    v-else
                                                    src="/images/add.png"
                                                />
                                            </q-item-section>
                                        </q-item>
                                    </q-list>
                                </div>
                            </div>

                            <!-- EMPTY LIST -->
                            <div class="row" v-else>
                                <div class="col-10 offset-md-1">
                                    <div class="text-center fixed-center">
                                        <q-img
                                            src="/images/invite.png"
                                            width="65px"
                                            height="65px"
                                        />
                                        <p
                                            class="
                                                q-py-md
                                                helvetica-neue-light
                                                font-18
                                            "
                                        >
                                            {{ $t('invite.findUser') }}
                                        </p>
                                    </div>
                                </div>
                            </div>

                            <!-- INVITE BUTTON -->
                            <div class="row">
                                <div class="col-10 offset-md-1 text-right">
                                    <q-btn
                                        v-if="
                                            state.invitationList.length > 0 &&
                                            state.invitationBtn
                                        "
                                        size="16px"
                                        label="Invite"
                                        class="
                                            border-radius-10
                                            q-px-lg
                                            bg-647BD1
                                            text-white
                                        "
                                        @click="state.confirm = true"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </div>

    <!-- CONFIRM DIALOG -->
    <q-dialog v-model="state.confirm" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.confirmInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.cancel')"
                    color="grey-5"
                    class="border-radius-10"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
                <q-btn
                    :label="$t('button.confirm')"
                    color="primary"
                    class="border-radius-10"
                    padding="8px 18px"
                    unelevated
                    @click="inviteBtnPressed"
                />
            </q-card-actions>
        </q-card>
    </q-dialog>

    <!-- SUCCESS DIALOG -->
    <q-dialog v-model="state.success" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.successInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.ok')"
                    color="primary"
                    class="border-radius-10 full-width"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
            </q-card-actions>
        </q-card>
    </q-dialog>

    <!-- ERROR DIALOG -->
    <q-dialog v-model="state.error" persistent>
        <q-card class="border-radius-50 q-pa-lg" style="width: 300px">
            <q-card-section class="row items-center">
                <span class="q-ml-sm font-24 text-center">
                    {{ $t('invite.errorInvites') }}
                </span>
            </q-card-section>

            <q-card-actions align="center">
                <q-btn
                    :label="$t('button.retry')"
                    color="dark"
                    class="border-radius-10 full-width"
                    padding="8px 18px"
                    unelevated
                    v-close-popup
                />
            </q-card-actions>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import { defineComponent, ref, reactive, watch } from 'vue';
import { UserSearchResponseResult } from 'src/services/responses/user/UserSearchResponse';
import { UserSearchType } from 'src/services/enums/UserSearchType';
import Notifications from 'src/components/commons/Notifications.vue';
import AutoAssign from 'src/components/commons/AutoAssign.vue';
import { useWindowSize } from 'vue-window-size';


export default defineComponent({
    components: { Notifications, AutoAssign },
    name: 'Invite',
    setup() {
        // store
        const store = useStore();

        // data
        let search = ref('');

        const { width, height } = useWindowSize();

        let state = reactive({
            loadingState: ref(false),
            searchResults: ref(false),
            confirm: ref(false),
            success: ref(false),
            error: ref(false),
            invitationBtn: ref(false),
            selectedList: 0,
            searchList: [] as any,
            invitationList: [] as any
        });

        // watch
        watch(search, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                state.searchResults = false;
            }
        });

        // methods
        const searchFunction = async (search: string) => {
            state.loadingState = true;

            const result: UserSearchResponseResult = await store.dispatch(
                'user/search',
                {
                    type: UserSearchType.KEYWORD,
                    value: search
                }
            );

            if (result.users.length > 0) {
                state.loadingState = false;
                state.searchResults = true;
                state.searchList = result.users;
            } else {
                state.loadingState = false;
            }
        };

        const selectListPressed = (list: any) => {
            let newList = {
                id: list.id,
                name: list.name,
                imageUrl: list.imageUrl,
                status: 1
            };

            if (state.invitationList.length > 0) {
                const findIndex = state.invitationList.findIndex(
                    (element: any) => element.id == list.id
                );
                if (findIndex == -1) {
                    state.invitationList.push(newList);
                }
            } else {
                state.invitationList.push(newList);
            }

            state.selectedList = state.invitationList.length;

            // check for invitation button
            checkInvitationButton();
        };

        const selectInvitationListPressed = (id: number) => {
            const findIndex = state.invitationList.findIndex(
                (element: any) => element.id == id
            );

            if (findIndex != -1) {
                if (state.invitationList[findIndex].status == 1) {
                    state.invitationList[findIndex].status = 0;
                } else {
                    state.invitationList[findIndex].status = 1;
                }
            }

            state.selectedList = 0;

            for (const list of state.invitationList) {
                if (list.status == 1) {
                    state.selectedList = state.selectedList + 1;
                }
            }

            // check for invitation button
            checkInvitationButton();
        };

        const selectAllPressed = () => {
            state.selectedList = 0;

            for (const [index, list] of state.invitationList.entries()) {
                if (list.status != 2) {
                    state.invitationList[index].status = 1;
                    state.selectedList = state.selectedList + 1;
                }
            }
        };

        const checkInvitationButton = () => {
            state.invitationBtn = false;
            for (const list of state.invitationList) {
                if (list.status == 1) {
                    state.invitationBtn = true;
                }
            }
        };

        const inviteBtnPressed = async () => {
            state.confirm = false;

            let userIds = [];
            for (const list of state.invitationList) {
                userIds.push(list.id);
            }

            const result: any = await store.dispatch('member/inviteUser', {
                userIds,
                roleId: ''
            });

            if (result.status == 200) {
                // reset invitation list
                state.invitationList = [];
                search = ref('');

                // success dialog
                state.success = true;
            } else {
                // error dialog
                state.error = true;
            }
        };

        return {
            state,
            search,
            dense: ref(true),
            selectListPressed,
            selectInvitationListPressed,
            selectAllPressed,
            inviteBtnPressed,
            windowWidth: width,
        };
    }
});
</script>
